diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShaped.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShaped.java
index fa6c2000e..80e8f6a5b 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShaped.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShaped.java
@@ -15,7 +15,12 @@ import java.util.List;
 import java.util.Objects;
 
 public class RecipeEntryCraftingShaped extends RecipeEntryCrafting<RecipeSymbol[], ItemStack> implements HasJsonAdapter {
+    // Changing defaults can have unexpected consequences, probably best to not ever change them
+    public static final boolean DEFAULT_CONSUME_CONTAINER = false;
+    public static final boolean DEFAULT_ALLOW_MIRROR = true;
+
     public boolean consumeContainerItem;
+    public boolean allowMirrored;
     public final int recipeWidth;
     public final int recipeHeight;
 
@@ -23,12 +28,22 @@ public class RecipeEntryCraftingShaped extends RecipeEntryCrafting<RecipeSymbol[
         super(input, output);
         this.recipeWidth = recipeWidth;
         this.recipeHeight = recipeHeight;
-        this.consumeContainerItem = false;
+        this.consumeContainerItem = DEFAULT_CONSUME_CONTAINER;
+        this.allowMirrored = DEFAULT_ALLOW_MIRROR;
     }
 
     public RecipeEntryCraftingShaped(int recipeWidth, int recipeHeight, RecipeSymbol[] input, ItemStack output, boolean consumeContainerItem) {
         super(input, output);
         this.consumeContainerItem = consumeContainerItem;
+        this.allowMirrored = DEFAULT_ALLOW_MIRROR;
+        this.recipeWidth = recipeWidth;
+        this.recipeHeight = recipeHeight;
+    }
+
+    public RecipeEntryCraftingShaped(int recipeWidth, int recipeHeight, RecipeSymbol[] input, ItemStack output, boolean consumeContainerItem, boolean allowMirrored) {
+        super(input, output);
+        this.consumeContainerItem = consumeContainerItem;
+        this.allowMirrored = allowMirrored;
         this.recipeWidth = recipeWidth;
         this.recipeHeight = recipeHeight;
     }
@@ -36,16 +51,18 @@ public class RecipeEntryCraftingShaped extends RecipeEntryCrafting<RecipeSymbol[
     public RecipeEntryCraftingShaped() {
         this.recipeWidth = 0;
         this.recipeHeight = 0;
+        this.consumeContainerItem = DEFAULT_CONSUME_CONTAINER;
+        this.allowMirrored = DEFAULT_ALLOW_MIRROR;
     }
 
     @Override
-    public boolean matches(CraftingContainer inventory) {
-        for (int i = 0; i <= 3 - recipeWidth; i++) {
-            for (int j = 0; j <= 3 - recipeHeight; j++) {
-                if (isRecipeMatching(inventory, i, j, true)) {
+    public boolean matches(CraftingContainer craftingContainer) {
+        for (int _w = 0; _w <= 3 - recipeWidth; _w++) {
+            for (int _h = 0; _h <= 3 - recipeHeight; _h++) {
+                if (allowMirrored && isRecipeMatching(craftingContainer, _w, _h, true)) {
                     return true;
                 }
-                if (isRecipeMatching(inventory, i, j, false)) {
+                if (isRecipeMatching(craftingContainer, _w, _h, false)) {
                     return true;
                 }
             }
@@ -135,14 +152,14 @@ public class RecipeEntryCraftingShaped extends RecipeEntryCrafting<RecipeSymbol[
         return false;
     }
 
-    private boolean isRecipeMatching(CraftingContainer inventory, int i, int j, boolean flag) {
+    private boolean isRecipeMatching(CraftingContainer inventory, int x, int y, boolean mirror) {
         for (int k = 0; k < 3; k++) {
             for (int l = 0; l < 3; l++) {
-                int i1 = k - i;
-                int j1 = l - j;
+                int i1 = k - x;
+                int j1 = l - y;
                 RecipeSymbol symbol = null;
                 if (i1 >= 0 && j1 >= 0 && i1 < recipeWidth && j1 < recipeHeight) {
-                    if (flag) {
+                    if (mirror) {
                         symbol = getInput()[(recipeWidth - i1 - 1) + j1 * recipeWidth];
                     } else {
                         symbol = getInput()[i1 + j1 * recipeWidth];
@@ -170,21 +187,21 @@ public class RecipeEntryCraftingShaped extends RecipeEntryCrafting<RecipeSymbol[
     }
 
     @Override
-    public ItemStack getCraftingResult(CraftingContainer inventorycrafting) {
+    public ItemStack getCraftingResult(CraftingContainer craftingContainer) {
         return new ItemStack(getOutput().itemID, getOutput().stackSize, getOutput().getMetadata());
     }
 
     @Override
-    public ItemStack[] onCraftResult(CraftingContainer inventorycrafting) {
+    public ItemStack[] onCraftResult(CraftingContainer craftingContainer) {
         ItemStack[] returnStack = new ItemStack[9];
-        for (int i = 0; i < inventorycrafting.getContainerSize(); i++) {
-            ItemStack itemstack1 = inventorycrafting.getItem(i);
+        for (int i = 0; i < craftingContainer.getContainerSize(); i++) {
+            ItemStack itemstack1 = craftingContainer.getItem(i);
             if (itemstack1 == null) {
                 continue;
             }
-            inventorycrafting.removeItem(i, 1);
+            craftingContainer.removeItem(i, 1);
             if (!consumeContainerItem && itemstack1.getItem().hasContainerItem()) {
-                inventorycrafting.setItem(i, new ItemStack(itemstack1.getItem().getContainerItem()));
+                craftingContainer.setItem(i, new ItemStack(itemstack1.getItem().getContainerItem()));
             }
         }
         return returnStack;
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShapeless.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShapeless.java
index 8547ed7cd..81e7fce33 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShapeless.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShapeless.java
@@ -23,7 +23,7 @@ public class RecipeEntryCraftingShapeless extends RecipeEntryCrafting<List<Recip
     public RecipeEntryCraftingShapeless() {}
 
     @Override
-    public boolean matches(CraftingContainer inventorycrafting)
+    public boolean matches(CraftingContainer craftingContainer)
     {
         ArrayList<RecipeSymbol> arraylist = new ArrayList<>(getInput());
         int i = 0;
@@ -35,7 +35,7 @@ public class RecipeEntryCraftingShapeless extends RecipeEntryCrafting<List<Recip
             }
             for(int j = 0; j < 3; j++)
             {
-                ItemStack itemstack = inventorycrafting.getItemStackAt(j, i);
+                ItemStack itemstack = craftingContainer.getItemStackAt(j, i);
                 if(itemstack == null)
                 {
                     continue;
@@ -141,26 +141,26 @@ public class RecipeEntryCraftingShapeless extends RecipeEntryCrafting<List<Recip
     }
 
     @Override
-    public ItemStack[] onCraftResult(CraftingContainer inventorycrafting){
+    public ItemStack[] onCraftResult(CraftingContainer craftingContainer){
         ItemStack[] returnStack = new ItemStack[9];
-        for(int i = 0; i < inventorycrafting.getContainerSize(); i++)
+        for(int i = 0; i < craftingContainer.getContainerSize(); i++)
         {
-            ItemStack itemStack = inventorycrafting.getItem(i);
+            ItemStack itemStack = craftingContainer.getItem(i);
             if(itemStack == null)
             {
                 continue;
             }
-            inventorycrafting.removeItem(i, 1);
+            craftingContainer.removeItem(i, 1);
             if(itemStack.getItem().hasContainerItem())
             {
-                inventorycrafting.setItem(i, new ItemStack(itemStack.getItem().getContainerItem()));
+                craftingContainer.setItem(i, new ItemStack(itemStack.getItem().getContainerItem()));
             }
         }
         return returnStack;
     }
 
     @Override
-    public ItemStack getCraftingResult(CraftingContainer inventorycrafting)
+    public ItemStack getCraftingResult(CraftingContainer craftingContainer)
     {
         return getOutput().copy();
     }
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingWithTool.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingWithTool.java
index 996e881ca..c20817f61 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingWithTool.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingWithTool.java
@@ -1,32 +1,45 @@
 package net.minecraft.core.data.registry.recipe.entry;
 
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.data.registry.recipe.HasJsonAdapter;
+import net.minecraft.core.data.registry.recipe.RecipeGroup;
+import net.minecraft.core.data.registry.recipe.RecipeNamespace;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
+import net.minecraft.core.data.registry.recipe.adapter.RecipeEntryCraftingWithToolJsonAdapter;
+import net.minecraft.core.data.registry.recipe.adapter.RecipeJsonAdapter;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.CraftingContainer;
 
-public class RecipeEntryCraftingWithTool extends RecipeEntryCraftingDynamic {
-    public RecipeEntryCraftingWithTool(ItemStack inItemStack, Item toolToUse, ItemStack output) {
-        this.inItemStack = inItemStack;
-        this.toolToUse = toolToUse;
-        this.output = output;
-    }
+import java.util.List;
+import java.util.Objects;
 
+public class RecipeEntryCraftingWithTool extends RecipeEntryCraftingDynamic implements HasJsonAdapter {
+    public RecipeSymbol inputSymbol;
+    public RecipeSymbol toolToUse;
+    public ItemStack output;
     public RecipeEntryCraftingWithTool() {
     }
 
+    public RecipeEntryCraftingWithTool(RecipeSymbol inputSymbol, RecipeSymbol toolToUse, ItemStack output) {
+        this.inputSymbol = inputSymbol;
+        this.toolToUse = toolToUse;
+        this.output = output;
+    }
+
     @Override
-    public boolean matches(CraftingContainer inventorycrafting) {
+    public boolean matches(CraftingContainer craftingContainer) {
         boolean toolMatch = false;
         boolean itemMatch = false;
 
         for (int x = 0; x < 3; x++) {
             for (int y = 0; y < 3; y++) {
-                ItemStack stack = inventorycrafting.getItemStackAt(x, y);
+                ItemStack stack = craftingContainer.getItemStackAt(x, y);
                 if (stack == null) continue;
-                if (stack.itemID == toolToUse.id) {
+                if (toolToUse.matches(stack)) {
                     toolMatch = true;
-                } else if (stack.itemID == inItemStack.itemID) {
+                } else if (inputSymbol.matches(stack)) {
                     itemMatch = true;
                 } else {
                     return false;
@@ -40,24 +53,99 @@ public class RecipeEntryCraftingWithTool extends RecipeEntryCraftingDynamic {
 
     @Override
     public boolean matchesQuery(SearchQuery query) {
+        switch (query.mode){
+            case ALL: {
+                if ((matchesRecipe(query) || matchesUsage(query)) && matchesScope(query)) return true;
+                break;
+            }
+            case RECIPE: {
+                if (matchesRecipe(query) && matchesScope(query)) return true;
+                break;
+            }
+            case USAGE: {
+                if (matchesUsage(query) && matchesScope(query)) return true;
+                break;
+            }
+        }
+        return false;
+    }
+
+    public boolean matchesScope(SearchQuery query){
+        if(query.scope.getLeft() == SearchQuery.SearchScope.NONE) return true;
+        if(query.scope.getLeft() == SearchQuery.SearchScope.NAMESPACE) {
+            RecipeNamespace namespace = Registries.RECIPES.getItem(query.scope.getRight());
+            if(namespace == parent.getParent()){
+                return true;
+            }
+        } else if (query.scope.getLeft() == SearchQuery.SearchScope.NAMESPACE_GROUP) {
+            RecipeGroup group;
+            try {
+                group = Registries.RECIPES.getGroupFromKey(query.scope.getRight());
+            } catch (IllegalArgumentException e){
+                group = null;
+            }
+            if(group == parent){
+                return true;
+            }
+        }
+        return false;
+    }
+
+    public boolean matchesRecipe(SearchQuery query) {
+        if(query.query.getLeft() == SearchQuery.QueryType.NAME) {
+            if(query.strict && output.getDisplayName().equalsIgnoreCase(query.query.getRight())){
+                return true;
+            } else if(!query.strict && output.getDisplayName().toLowerCase().contains(query.query.getRight().toLowerCase())){
+                return true;
+            }
+        } else if (query.query.getLeft() == SearchQuery.QueryType.GROUP && !Objects.equals(query.query.getRight(), "")) {
+            List<ItemStack> groupStacks = new RecipeSymbol(query.query.getRight()).resolve();
+            if(groupStacks == null) return false;
+            return groupStacks.contains(output);
+        }
+        return false;
+    }
+
+    public boolean matchesUsage(SearchQuery query) {
+        RecipeSymbol[] symbols = {inputSymbol, toolToUse};
+        for (RecipeSymbol symbol : symbols) {
+            if(symbol == null) continue;
+            List<ItemStack> stacks = symbol.resolve();
+            if(query.query.getLeft() == SearchQuery.QueryType.NAME) {
+                for (ItemStack stack : stacks) {
+                    if(query.strict && stack.getDisplayName().equalsIgnoreCase(query.query.getRight())){
+                        return true;
+                    } else if (!query.strict && stack.getDisplayName().toLowerCase().contains(query.query.getRight().toLowerCase())) {
+                        return true;
+                    }
+                }
+            } else if (query.query.getLeft() == SearchQuery.QueryType.GROUP && !Objects.equals(query.query.getRight(), "")) {
+                List<ItemStack> groupStacks = new RecipeSymbol(query.query.getRight()).resolve();
+                if(groupStacks == null) return false;
+                if(stacks.stream().anyMatch((groupStacks::contains))){
+                    return true;
+                }
+            }
+
+        }
         return false;
     }
 
     @Override
-    public ItemStack getCraftingResult(CraftingContainer inventorycrafting) {
+    public ItemStack getCraftingResult(CraftingContainer craftingContainer) {
         return new ItemStack(output.itemID, output.stackSize, output.getMetadata());
     }
 
     @Override
-    public ItemStack[] onCraftResult(CraftingContainer inventorycrafting) {
+    public ItemStack[] onCraftResult(CraftingContainer craftingContainer) {
         ItemStack[] returnStack = new ItemStack[9];
         for (int x = 0; x < 3; x++) {
             for (int y = 0; y < 3; y++) {
-                ItemStack stack = inventorycrafting.getItemStackAt(x, y);
+                ItemStack stack = craftingContainer.getItemStackAt(x, y);
                 if (stack == null) continue;
                 ItemStack stack2;
 
-                if(stack.getItem() == toolToUse){
+                if(toolToUse.matches(new ItemStack(stack))){
                     if (stack.getMetadata() + 1 > stack.getMaxDamage())
                         stack2 = null;
                     else {
@@ -70,7 +158,7 @@ public class RecipeEntryCraftingWithTool extends RecipeEntryCraftingDynamic {
                         stack2 = new ItemStack(stack.getItem(), stack.stackSize - 1);
                     }
                 }
-                inventorycrafting.setSlotContentsAt(x, y, stack2);
+                craftingContainer.setSlotContentsAt(x, y, stack2);
             }
         }
         return returnStack;
@@ -81,7 +169,8 @@ public class RecipeEntryCraftingWithTool extends RecipeEntryCraftingDynamic {
         return 2;
     }
 
-    public ItemStack inItemStack;
-    public Item toolToUse;
-    public ItemStack output;
+    @Override
+    public RecipeJsonAdapter<?> getAdapter() {
+        return new RecipeEntryCraftingWithToolJsonAdapter();
+    }
 }
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryLabel.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryLabel.java
index 70a0770a9..c03d85fc6 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryLabel.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryLabel.java
@@ -1,19 +1,26 @@
 package net.minecraft.core.data.registry.recipe.entry;
 
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.data.registry.recipe.RecipeGroup;
+import net.minecraft.core.data.registry.recipe.RecipeNamespace;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.CraftingContainer;
 
+import java.util.List;
+import java.util.Objects;
+
 public class RecipeEntryLabel extends RecipeEntryCraftingDynamic {
     @Override
-    public ItemStack getCraftingResult(final CraftingContainer inventorycrafting) {
+    public ItemStack getCraftingResult(final CraftingContainer craftingContainer) {
         ItemStack labelStack = null;
         ItemStack otherItem = null;
 
         label0: for(int x = 0; x < 3; x++) {
             for(int y = 0; y < 3; y++) {
-                final ItemStack stack = inventorycrafting.getItemStackAt(x, y);
+                final ItemStack stack = craftingContainer.getItemStackAt(x, y);
                 if(stack == null) {
                     continue;
                 }
@@ -48,13 +55,13 @@ public class RecipeEntryLabel extends RecipeEntryCraftingDynamic {
     }
 
     @Override
-    public boolean matches(final CraftingContainer crafting) {
+    public boolean matches(final CraftingContainer craftingContainer) {
         ItemStack labelStack = null;
         ItemStack otherStack = null;
 
         for(int x = 0; x < 3; x++) {
             for(int y = 0; y < 3; y++) {
-                final ItemStack stack = crafting.getItemStackAt(x, y);
+                final ItemStack stack = craftingContainer.getItemStackAt(x, y);
                 if(stack == null) {
                     continue;
                 }
@@ -107,22 +114,86 @@ public class RecipeEntryLabel extends RecipeEntryCraftingDynamic {
 
     @Override
     public boolean matchesQuery(SearchQuery query) {
+        switch (query.mode){
+            case ALL: {
+                if ((matchesRecipe(query) || matchesUsage(query)) && matchesScope(query)) return true;
+                break;
+            }
+            case RECIPE: {
+                if (matchesRecipe(query) && matchesScope(query)) return true;
+                break;
+            }
+            case USAGE: {
+                if (matchesUsage(query) && matchesScope(query)) return true;
+                break;
+            }
+        }
+        return false;
+    }
+
+    public boolean matchesScope(SearchQuery query){
+        if(query.scope.getLeft() == SearchQuery.SearchScope.NONE) return true;
+        if(query.scope.getLeft() == SearchQuery.SearchScope.NAMESPACE) {
+            RecipeNamespace namespace = Registries.RECIPES.getItem(query.scope.getRight());
+            if(namespace == parent.getParent()){
+                return true;
+            }
+        } else if (query.scope.getLeft() == SearchQuery.SearchScope.NAMESPACE_GROUP) {
+            RecipeGroup group;
+            try {
+                group = Registries.RECIPES.getGroupFromKey(query.scope.getRight());
+            } catch (IllegalArgumentException e){
+                group = null;
+            }
+            if(group == parent){
+                return true;
+            }
+        }
+        return false;
+    }
+
+    public boolean matchesRecipe(SearchQuery query) {
+        return false;
+    }
+
+    public boolean matchesUsage(SearchQuery query) {
+        RecipeSymbol[] symbols = {new RecipeSymbol(Items.LABEL.getDefaultStack())};
+        for (RecipeSymbol symbol : symbols) {
+            if(symbol == null) continue;
+            List<ItemStack> stacks = symbol.resolve();
+            if(query.query.getLeft() == SearchQuery.QueryType.NAME) {
+                for (ItemStack stack : stacks) {
+                    if(query.strict && stack.getDisplayName().equalsIgnoreCase(query.query.getRight())){
+                        return true;
+                    } else if (!query.strict && stack.getDisplayName().toLowerCase().contains(query.query.getRight().toLowerCase())) {
+                        return true;
+                    }
+                }
+            } else if (query.query.getLeft() == SearchQuery.QueryType.GROUP && !Objects.equals(query.query.getRight(), "")) {
+                List<ItemStack> groupStacks = new RecipeSymbol(query.query.getRight()).resolve();
+                if(groupStacks == null) return false;
+                if(stacks.stream().anyMatch((groupStacks::contains))){
+                    return true;
+                }
+            }
+
+        }
         return false;
     }
 
     @Override
-    public ItemStack[] onCraftResult(final CraftingContainer crafting) {
+    public ItemStack[] onCraftResult(final CraftingContainer craftingContainer) {
         final ItemStack[] returnStack = new ItemStack[9];
         for(int x = 0; x < 3; x++) {
             for(int y = 0; y < 3; y++) {
-                final ItemStack stack = crafting.getItemStackAt(x, y);
+                final ItemStack stack = craftingContainer.getItemStackAt(x, y);
                 if(stack == null) {
                     continue;
                 }
                 if(stack.itemID != Items.LABEL.id) {
                     stack.stackSize--;
                     if(stack.stackSize <= 0) {
-                        crafting.setSlotContentsAt(x, y, null);
+                        craftingContainer.setSlotContentsAt(x, y, null);
                     }
                 }
             }
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryLabelDye.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryLabelDye.java
index 17c5b0331..28f7a448a 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryLabelDye.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryLabelDye.java
@@ -1,19 +1,26 @@
 package net.minecraft.core.data.registry.recipe.entry;
 
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.data.registry.recipe.RecipeGroup;
+import net.minecraft.core.data.registry.recipe.RecipeNamespace;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.CraftingContainer;
 
+import java.util.List;
+import java.util.Objects;
+
 public class RecipeEntryLabelDye extends RecipeEntryCraftingDynamic{
     @Override
-    public ItemStack getCraftingResult(final CraftingContainer inventorycrafting) {
+    public ItemStack getCraftingResult(final CraftingContainer craftingContainer) {
         ItemStack labelStack = null;
         ItemStack dyeStack = null;
 
         label0: for(int x = 0; x < 3; x++) {
             for(int y = 0; y < 3; y++) {
-                final ItemStack stack = inventorycrafting.getItemStackAt(x, y);
+                final ItemStack stack = craftingContainer.getItemStackAt(x, y);
                 if(stack == null) {
                     continue;
                 }
@@ -45,13 +52,13 @@ public class RecipeEntryLabelDye extends RecipeEntryCraftingDynamic{
     }
 
     @Override
-    public boolean matches(final CraftingContainer crafting) {
+    public boolean matches(final CraftingContainer craftingContainer) {
         ItemStack labelStack = null;
         ItemStack dyeStack = null;
 
         for(int x = 0; x < 3; x++) {
             for(int y = 0; y < 3; y++) {
-                final ItemStack stack = crafting.getItemStackAt(x, y);
+                final ItemStack stack = craftingContainer.getItemStackAt(x, y);
                 if(stack == null) {
                     continue;
                 }
@@ -84,21 +91,97 @@ public class RecipeEntryLabelDye extends RecipeEntryCraftingDynamic{
 
     @Override
     public boolean matchesQuery(SearchQuery query) {
+        switch (query.mode){
+            case ALL: {
+                if ((matchesRecipe(query) || matchesUsage(query)) && matchesScope(query)) return true;
+                break;
+            }
+            case RECIPE: {
+                if (matchesRecipe(query) && matchesScope(query)) return true;
+                break;
+            }
+            case USAGE: {
+                if (matchesUsage(query) && matchesScope(query)) return true;
+                break;
+            }
+        }
+        return false;
+    }
+
+    public boolean matchesScope(SearchQuery query){
+        if(query.scope.getLeft() == SearchQuery.SearchScope.NONE) return true;
+        if(query.scope.getLeft() == SearchQuery.SearchScope.NAMESPACE) {
+            RecipeNamespace namespace = Registries.RECIPES.getItem(query.scope.getRight());
+            if(namespace == parent.getParent()){
+                return true;
+            }
+        } else if (query.scope.getLeft() == SearchQuery.SearchScope.NAMESPACE_GROUP) {
+            RecipeGroup group;
+            try {
+                group = Registries.RECIPES.getGroupFromKey(query.scope.getRight());
+            } catch (IllegalArgumentException e){
+                group = null;
+            }
+            if(group == parent){
+                return true;
+            }
+        }
+        return false;
+    }
+
+    public boolean matchesRecipe(SearchQuery query) {
+        ItemStack output = Items.LABEL.getDefaultStack();
+        if(query.query.getLeft() == SearchQuery.QueryType.NAME) {
+            if(query.strict && output.getDisplayName().equalsIgnoreCase(query.query.getRight())){
+                return true;
+            } else if(!query.strict && output.getDisplayName().toLowerCase().contains(query.query.getRight().toLowerCase())){
+                return true;
+            }
+        } else if (query.query.getLeft() == SearchQuery.QueryType.GROUP && !Objects.equals(query.query.getRight(), "")) {
+            List<ItemStack> groupStacks = new RecipeSymbol(query.query.getRight()).resolve();
+            if(groupStacks == null) return false;
+            return groupStacks.contains(output);
+        }
+        return false;
+    }
+
+    public boolean matchesUsage(SearchQuery query) {
+        RecipeSymbol[] symbols = {new RecipeSymbol(Items.LABEL.getDefaultStack()), new RecipeSymbol(new ItemStack(Items.DYE, 1, -1))};
+        for (RecipeSymbol symbol : symbols) {
+            if(symbol == null) continue;
+            List<ItemStack> stacks = symbol.resolve();
+            if(query.query.getLeft() == SearchQuery.QueryType.NAME) {
+                for (ItemStack stack : stacks) {
+                    if(query.strict && stack.getDisplayName().equalsIgnoreCase(query.query.getRight())){
+                        return true;
+                    } else if (!query.strict && stack.getDisplayName().toLowerCase().contains(query.query.getRight().toLowerCase())) {
+                        return true;
+                    }
+                }
+            } else if (query.query.getLeft() == SearchQuery.QueryType.GROUP && !Objects.equals(query.query.getRight(), "")) {
+                List<ItemStack> groupStacks = new RecipeSymbol(query.query.getRight()).resolve();
+                if(groupStacks == null) return false;
+                if(stacks.stream().anyMatch((groupStacks::contains))){
+                    return true;
+                }
+            }
+
+        }
         return false;
     }
 
     @Override
-    public ItemStack[] onCraftResult(final CraftingContainer crafting) {
+    public ItemStack[] onCraftResult(final CraftingContainer craftingContainer) {
         final ItemStack[] returnStack = new ItemStack[9];
         for(int x = 0; x < 3; x++) {
             for(int y = 0; y < 3; y++) {
-                final ItemStack stack = crafting.getItemStackAt(x, y);
+                final ItemStack stack = craftingContainer.getItemStackAt(x, y);
                 if(stack == null) {
                     continue;
                 }
                 stack.stackSize--;
                 if(stack.stackSize <= 0) {
-                    crafting.setSlotContentsAt(x, y, null);
+                    craftingContainer.setSlotContentsAt(x, y, null);
                 }
             }
         }
